<cfsetting enablecfoutputonly="true">
<cfscript>

	declareAttribute("month","string");
	declareAttribute("index","string");

	function doStartTag() {		
		nextDate();
		writeCalendarStart();
	}
	
	function doEndTag() {
		if( day(thisTag.date) eq daysInMonth(thisTag.date) ) {
			writeCalendarEnd();
		} else {
			nextDate();

			if( dayOfWeek(thisTag.date) eq 1 )
				writeWeekRestart();
			
			writeDayStart();
			loopTag();
		}
	}
		
	function nextDate() {
		if( not structKeyExists(thisTag,"date") ) {
			thisTag.date = "#attributes.month#/1/#year(now())#";
		} else {
			thisTag.date = thisTag.date + 1;
		}
		caller[attributes.index] = thisTag.date;
	}
	
	function writeWeekRestart() {
		writeOutput("</tr><tr>");
	}
	
	function writeCalendarStart() {
		writeOutput('<table border="1"><tr>');
		writeOutput(repeatString("<td></td>",dayOfWeek(thisTag.date)-1));
		writeDayStart();
	}
	
	function writeCalendarEnd() {
		writeDayEnd();
		writeOutput(repeatString("<td></td>",7-dayOfWeek(thisTag.date)));
		writeOutput('</tr></table>');
	}
	
	function writeDayStart() {
		writeOutput('<td class="day-#dayOfWeekAsString(dayOfWeek(thisTag.date))#">');
	}
	
	function writeDayEnd() {
		writeOutput('</td>');
	}
	
</cfscript>

<cffunction name="loopTag" access="public" returntype="any" output="false">
	<cfexit method="loop">
</cffunction>

<cffunction name="exitTag" access="public" returntype="any" output="false">
	<cfexit method="exittag">
</cffunction>

<cffunction name="doNothing" access="public" returntype="any" output="false">
</cffunction>

<cffunction name="declareAttribute" access="public" returntype="any" output="false">
	<cfargument name="name" type="string" required="true">
	<cfargument name="type" type="string" required="true">
	<cfargument name="default" type="any" required="false">
		
	<cfset arguments.name = "attributes.#arguments.name#">
	<cfparam attributecollection="#arguments#">
</cffunction>

<cfif thisTag.executionMode eq "start">	
	<cfset doStartTag()>
	<cfset variables.declareAttribute = doNothing>
<cfelse>
	<cfset doEndTag()>
</cfif>

<cfsetting enablecfoutputonly="false">