<cfscript>
	function bindFunction( func, context ) {
		var metaData = getMetaData(func);		
		var params = metaData.parameters;
		var passedArgs = "args[1],args[2],args[3],args[4],args[5],args[6],args[7],";		
		var i = "";
		
		if( arrayLen(params) lte 5 ) {
			passedArgs = mid(passedArgs,1,8*arrayLen(params));
		} else {
			for( i=8; i lte arrayLen(params); i = i + 1 )
				passedArgs &= "args[#i#],";
		}
		
		metaData.context = context;
		metaData.passedArgs = passedArgs & "context,metaData";
		
		return func;
	}
	
	function applyFunction( func ) {
		var metaData = getMetaData(func);
		var context = metaData.context;
		var params = metaData.parameters;
		var passedArgs = metaData.passedArgs;
		var args = structNew();
		var i = "";
		
		if( structCount(arguments) gt 1 )
			args = arguments[2];
		
		if( structCount(arguments) gt 2 )
			context = arguments[3];
									
		if( isArray(args) ) {
			if( arrayLen(params) eq 1 ) {
				return func(args[1],context,metaData);				
			} else if( arrayLen(params) eq 2 ) {
				return func(args[1],args[2],context,metaData);
			} else {
				return evaluate("func(#passedArgs#context,metaData)");
			}
		} else {
			args.variables = context;
			args.metadata = metaData;
			
			return func( argumentCollection=args );
		}
	}
	
	function test( a, b ) {
		writeOutput(a+b);
	}
		
	bindFunction( test, variables );
	
	args = [ 1,2 ];
	
	t = getTickCount();
	for( i=1; i <= 10000; i++ )	
		r = test(1,2);
	t = getTickCount()-t;
	writeOutput(t & "<br>");
			
	t = getTickCount();
	for( i=1; i <= 10000; i++ )
		r = applyFunction( test, args );
	t = getTickCount()-t;
	writeOutput(t & "<br>");
		
</cfscript>