<!---
Metadata is static like with components, and can be used to store static, function specifc information. 
	- Cannot be referenced inside a function unforunately. (We'll fix this with an API)
	
Can be used to create closures by storing the context on the function, then applying the context later using argument tricks.
--->

<cfscript>
function f( variables, this ) {
	variables.i + 1;
	this.i + 1;
}
</cfscript>

<!---
Will use arguments, can use the trick of <cfargument name="variables" required="false" default="#structGet('variables')#"> to bind variables and this for defaults to allow "safe function pointer moving".

This allows a function to both execute with and without a context.

Can't use default="#variables#" because that'd be null since it evals to the argument, not the variables scopes. (It this a bug? Or expected? Why?).

<cffunction> must contain static metadata since all attributes must be constants. Arguments can contain arbitrary attributes like metadata="#structNew()#". This is a neat way to bind extra runtime information.
--->

<cfscript>	
	function structExister( a, variables ) {
		return structkeyExists(variables.data,a);
	}

	bindClosure( structExister, variables );

	args = { a="abc" }
	applyClosure( structExister, args );

//or:

	getMetaData(structExister).apply(structExister,args);
</cfscript>